import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.io.*;
import java.util.*;
import javax.swing.filechooser.*;
import java.text.*;
import java.applet.*;
import java.net.*;
/*
 * BridgeScore.java
 * Created on October 18, 2003, 8:18 PM
 * @author  Administrator
 */
public class BridgeScore extends javax.swing.JFrame {
    // Instance variables
    // These will be initialized in the constructor
    DefaultListModel   NSListModel, EWListModel, BoardListModel;
    ResultTable        NSResults, EWResults;
    MovementDefinition mDef;
    BoardData[]        boardArray;
    // System state data:
    int                iCurrentBoard;
    int                iCurrentScoreEntry;
    int                iState;
    // These are the possible states:
    static final int   BOARD_NUMBER = 1;
    static final int   SCORE = 2;
    static final int   CONFIRM = 3;
    static final int   MAX_MOVEMENT_ENTRIES = 200;
    static final int   MAX_BOARD_ROWS = 10;
    
    ImageIcon MyIcon16;
    ImageIcon MyIcon32;
    Image MyImage16;
    Image MyImage32;
    MyCanvas canvas1;
    Toolkit toolkit;
    boolean bDataHasBeenExported;
    String sCurrentDir;
    String sHomeDir;
    AudioClip fanfare;
        
    /** Creates new form BridgeScore */
    public BridgeScore() {
        
        sCurrentDir = System.getProperty("user.dir");
        sHomeDir = System.getProperty("user.home");
        fanfare = LoadAudioClip.make("TheWinnersAre.wav");
        bDataHasBeenExported = false;
        toolkit = Toolkit.getDefaultToolkit();
        // Read 16x16 and 32x32 Icons
        MyIcon16 = new ImageIcon("heart.jpg");
        MyImage16 = MyIcon16.getImage();
        MediaTracker mediaTracker16 = new MediaTracker(this);
        mediaTracker16.addImage(MyImage16, 0);
        try
            { mediaTracker16.waitForID(0); }
        catch (InterruptedException ie)
            {System.err.println(ie); System.exit(1); }
        
        setIconImage(MyImage16);  //Icon is heart   
        // The following line enables us to take control of window closure
        // See method exitForm.
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        
        MyIcon32 = new ImageIcon("HeartCSD.gif");
        MyImage32 = MyIcon32.getImage();
        MediaTracker mediaTracker32 = new MediaTracker(this);
        mediaTracker32.addImage(MyImage32, 0);
        try
            { mediaTracker32.waitForID(0); }
        catch (InterruptedException ie)
            {System.err.println(ie); System.exit(1); }
        
        initComponents();
        
        canvas1 = new MyCanvas(MyImage32);
        canvas1.setSize(32,32);
        jPanel4.add(canvas1);
        pack();
        
        File sMovementID;
        setTitle("Quick Bridge Score 1.5");
        // Start initializing the lists
        
        // Identify the desired movement, read the properties and data,
        //     and construct the results tables.
        mDef = new MovementDefinition(MAX_MOVEMENT_ENTRIES);
        sMovementID = SelectMovement();
        LoadMovement(sMovementID);
        
        
        NSListModel = new DefaultListModel();
        NSResults = new ResultTable(mDef, 'N');
        NSResults.WriteTitleRows(NSListModel);
        NSList.setModel(NSListModel);
        NSList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
       
        EWListModel = new DefaultListModel();
        EWResults = new ResultTable(mDef, 'E');
        EWResults.WriteTitleRows(EWListModel);
        EWList.setModel(EWListModel);
        EWList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        
        Dimension dDim = new Dimension(NSResults.WidthRequirement(),
                NSResults.HeightRequirement());
        Dimension dZap = new Dimension(0,0);
        
        NSList.setPreferredSize(dDim);
        NSList.setMinimumSize(dDim);
        NSList.setMaximumSize(dDim);
        if (mDef.type == 'M') {
            EWList.setPreferredSize(dDim);
            EWList.setMinimumSize(dDim);
            EWList.setMaximumSize(dDim);
        } else {
            EWList.setPreferredSize(dZap);
            
            EWList.setVisible(false);
        }
        
        int i;
        boardArray = new BoardData[mDef.boards];
        //boardArray is now an array of references to BoardData, each of which is null
        int iMaxPlayed = 0;  // We need this to size the per-board score list
        for (i = 0; i < mDef.boards; i++) {
            boardArray[i] = new BoardData(i+1);
            if (boardArray[i].iHowOftenPlayed > iMaxPlayed) 
                iMaxPlayed = boardArray[i].iHowOftenPlayed;
        }
        
        BoardListModel = new DefaultListModel();
        BoardList.setModel(BoardListModel); 
        BoardListModel.addElement("  NS   EW   NS    EW   ");
        BoardListModel.addElement(" PAIR PAIR SCORE SCORE");
        BoardID.setText("  ");
        
        int iBoardListHeight = 20*(iMaxPlayed + 2);
        Dimension dDim2 = new Dimension(200, iBoardListHeight);
        BoardList.setPreferredSize(dDim2);
        BoardList.setMinimumSize(dDim2);
        BoardList.setMaximumSize(dDim2);
        // 
        // Size main frame to look neat
        int xReq, yReq;
        if (mDef.type == 'M')
            xReq = 4*16 + 200 + 2*NSResults.WidthRequirement();
        else
            xReq = 4*16 + 200 + NSResults.WidthRequirement();
        if (xReq < 470) xReq = 470;
        yReq = NSResults.HeightRequirement() + 200;
        setSize(xReq, yReq);
        
        
        iState = BOARD_NUMBER;
        DataEntryInstruction.setText("Enter Board Number:");
        InputField.requestFocus();
        // Fron here on, things are initiated by InputField events.
    } // End Constructor
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jPanel3 = new javax.swing.JPanel();
        NSList = new javax.swing.JList();
        jLabel1 = new javax.swing.JLabel();
        EWList = new javax.swing.JList();
        jLabel2 = new javax.swing.JLabel();
        jPanel6 = new javax.swing.JPanel();
        BoardID = new javax.swing.JLabel();
        BoardList = new javax.swing.JList();
        jLabel5 = new javax.swing.JLabel();
        PaneRight = new javax.swing.JPanel();
        LabelBoardNumber = new javax.swing.JLabel();
        DataEntryInstruction = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        InputField = new javax.swing.JTextField();
        jPanel2 = new javax.swing.JPanel();
        jPanel4 = new javax.swing.JPanel();
        jPanel5 = new javax.swing.JPanel();
        ShowWinnersButton = new javax.swing.JButton();
        ExportButton = new javax.swing.JButton();

        getContentPane().setLayout(new javax.swing.BoxLayout(getContentPane(), javax.swing.BoxLayout.Y_AXIS));

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        jPanel3.setLayout(new javax.swing.BoxLayout(jPanel3, javax.swing.BoxLayout.X_AXIS));

        NSList.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED, java.awt.Color.blue, java.awt.Color.blue, java.awt.Color.blue, java.awt.Color.blue));
        NSList.setFont(new java.awt.Font("Courier New", 1, 12));
        NSList.setMaximumSize(new java.awt.Dimension(1000, 800));
        NSList.setMinimumSize(new java.awt.Dimension(200, 300));
        NSList.setPreferredSize(new java.awt.Dimension(340, 530));
        NSList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                NSValueChanged(evt);
            }
        });

        jPanel3.add(NSList);

        jLabel1.setText("  ");
        jLabel1.setMaximumSize(new java.awt.Dimension(16, 16));
        jLabel1.setMinimumSize(new java.awt.Dimension(16, 16));
        jLabel1.setPreferredSize(new java.awt.Dimension(16, 16));
        jPanel3.add(jLabel1);

        EWList.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED, java.awt.Color.blue, java.awt.Color.blue, java.awt.Color.blue, java.awt.Color.blue));
        EWList.setFont(new java.awt.Font("Courier New", 1, 12));
        EWList.setMaximumSize(new java.awt.Dimension(1000, 700));
        EWList.setMinimumSize(new java.awt.Dimension(200, 300));
        EWList.setPreferredSize(new java.awt.Dimension(340, 530));
        EWList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                EWValueChanged(evt);
            }
        });

        jPanel3.add(EWList);

        jLabel2.setText("  ");
        jLabel2.setMaximumSize(new java.awt.Dimension(16, 16));
        jLabel2.setMinimumSize(new java.awt.Dimension(16, 16));
        jLabel2.setPreferredSize(new java.awt.Dimension(16, 16));
        jPanel3.add(jLabel2);

        jPanel6.setLayout(new javax.swing.BoxLayout(jPanel6, javax.swing.BoxLayout.Y_AXIS));

        BoardID.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        BoardID.setText("Data for Board xx");
        BoardID.setHorizontalTextPosition(javax.swing.SwingConstants.LEADING);
        jPanel6.add(BoardID);

        BoardList.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED, java.awt.Color.blue, java.awt.Color.blue, java.awt.Color.blue, java.awt.Color.blue));
        BoardList.setFont(new java.awt.Font("Courier New", 1, 14));
        BoardList.setAlignmentX(0.0F);
        BoardList.setMaximumSize(new java.awt.Dimension(200, 200));
        BoardList.setMinimumSize(new java.awt.Dimension(200, 100));
        BoardList.setPreferredSize(new java.awt.Dimension(200, 100));
        jPanel6.add(BoardList);

        jPanel3.add(jPanel6);

        getContentPane().add(jPanel3);

        jLabel5.setText("    ");
        getContentPane().add(jLabel5);

        PaneRight.setLayout(new java.awt.GridLayout(3, 1));

        PaneRight.setMaximumSize(new java.awt.Dimension(32767, 60));
        LabelBoardNumber.setFont(new java.awt.Font("Dialog", 1, 14));
        LabelBoardNumber.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        LabelBoardNumber.setText("                 ");
        PaneRight.add(LabelBoardNumber);

        DataEntryInstruction.setFont(new java.awt.Font("Dialog", 1, 14));
        DataEntryInstruction.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        DataEntryInstruction.setText(" Data Entry Instruction");
        PaneRight.add(DataEntryInstruction);

        jLabel9.setText("   ");
        PaneRight.add(jLabel9);

        getContentPane().add(PaneRight);

        InputField.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        InputField.setMaximumSize(new java.awt.Dimension(150, 20));
        InputField.setMinimumSize(new java.awt.Dimension(100, 20));
        InputField.setPreferredSize(new java.awt.Dimension(100, 20));
        InputField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                InputFieldActionPerformed(evt);
            }
        });
        InputField.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                InputFieldKeyTyped(evt);
            }
        });

        jPanel1.add(InputField);

        getContentPane().add(jPanel1);

        jPanel2.setLayout(new java.awt.GridLayout(1, 2));

        jPanel4.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        jPanel2.add(jPanel4);

        jPanel5.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT));

        ShowWinnersButton.setText("Show Winners");
        ShowWinnersButton.setEnabled(false);
        ShowWinnersButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                ShowWinnersMouseClicked(evt);
            }
        });

        jPanel5.add(ShowWinnersButton);

        ExportButton.setText("Export Data");
        ExportButton.setEnabled(false);
        ExportButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                ExportClicked(evt);
            }
        });

        jPanel5.add(ExportButton);

        jPanel2.add(jPanel5);

        getContentPane().add(jPanel2);

        pack();
    }//GEN-END:initComponents

    private void ExportClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_ExportClicked
        // Add your handling code here:
        if (ExportButton.isEnabled())
            ExportData();
    }//GEN-LAST:event_ExportClicked

    private void EWValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_EWValueChanged
        // Add your handling code here:
        if (iState != BOARD_NUMBER) {
            EWList.clearSelection();
        } else {
            int i = EWList.getSelectedIndex();
            NSList.setSelectedIndex(i);
            int nBoard = i - 1;
            // What we want to do here is to show the data entered for the selected board.  
            // But we must not allow this to interrupt data entry for a board.
            // So we have to examine iState.  iState must be BOARD_NUMBER.
            if (nBoard >= 1 && nBoard <= mDef.boards && iState == BOARD_NUMBER) {
                boardArray[nBoard-1].WriteUponList(BoardListModel);
            } else {
                EWList.clearSelection();
            }
        InputField.requestFocus();
        //JOptionPane.showMessageDialog(null,"ValueChanged " + Integer.toString(i));
        }
    }//GEN-LAST:event_EWValueChanged

    private void NSValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_NSValueChanged
        // Add your handling code here:
        if (iState != BOARD_NUMBER) {
            NSList.clearSelection();
        } else {
            int i = NSList.getSelectedIndex();
            EWList.setSelectedIndex(i);
            int nBoard = i - 1;
            if (nBoard >= 1 && nBoard <= mDef.boards && iState == BOARD_NUMBER) {
                boardArray[nBoard-1].WriteUponList(BoardListModel);
            } else {
                NSList.clearSelection();
            }
        InputField.requestFocus();
        //JOptionPane.showMessageDialog(null,"ValueChanged " + Integer.toString(i));
        }
    }//GEN-LAST:event_NSValueChanged

    private void ShowWinnersMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_ShowWinnersMouseClicked
        // Add your handling code here:
        if (ShowWinnersButton.isEnabled())
            ShowBothRankings();
    }//GEN-LAST:event_ShowWinnersMouseClicked

    private void InputFieldKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_InputFieldKeyTyped
        // Add your handling code here:
        int iNSP, iEWP, iKeycode;
        if (iState != CONFIRM) return; else {
            iKeycode = evt.getKeyChar();
            //JOptionPane.showMessageDialog(null,"Keycode is " + Integer.toString(iKeycode));
            if (iKeycode == 10 /*ENTER = line feed*/) {
                // We'll allow the blank line to be picked up by ProcessInputLine
                return;
            } else {
                // Data rejected, start re-entry
                iCurrentScoreEntry = 0;
                    // Look up the top pair number and display prompt
                iNSP = boardArray[iCurrentBoard - 1]
                        .BDcontent[iCurrentScoreEntry].NSpair;
                iEWP = boardArray[iCurrentBoard - 1]
                        .BDcontent[iCurrentScoreEntry].EWpair;
                DataEntryInstruction.setText("Score for NS "
                        + Integer.toString(iNSP) + " vs. EW "
                        + Integer.toString(iEWP) + ":");
                iState = SCORE;
                InputField.setText("");
            }
        }
    }//GEN-LAST:event_InputFieldKeyTyped

    private void InputFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_InputFieldActionPerformed
        // Add your handling code here:
        //JOptionPane.showMessageDialog(this,InputField.getText());
        ProcessInputLine(InputField.getText());
    }//GEN-LAST:event_InputFieldActionPerformed
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        if (!AllBoardsEntered()) {
            if(JOptionPane.showConfirmDialog(null,
                "You have not finished entering data.\nDo you really want to quit?",
                "Confirm Quit",JOptionPane.YES_NO_OPTION) 
            == JOptionPane.YES_OPTION) 
                System.exit(0);
        } else if (bDataHasBeenExported){
            // All boards have been entered, data exported
            if(JOptionPane.showConfirmDialog(null,
                "Do you really want to quit?",
                "Confirm Quit",JOptionPane.YES_NO_OPTION) 
            == JOptionPane.YES_OPTION) 
                System.exit(0);
        } else {
            // All boards entered, data not exported
            switch (JOptionPane.showConfirmDialog(null,
                "Do you want to save the results to a file",
                "Confirm Quit",JOptionPane.YES_NO_CANCEL_OPTION)) {
                case JOptionPane.YES_OPTION:
                    ExportData();
                    System.exit(0);
                    break;
                case JOptionPane.NO_OPTION:
                    System.exit(0);
                    break;
                case JOptionPane.CANCEL_OPTION:
                    // No action in this case, resume processing
            } // End switch
        } //End if-then-elseif-then-else
    }//GEN-LAST:event_exitForm
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        new BridgeScore().show();
        
    }
    
    void ProcessInputLine(String sL) {  // This is the main program loop! 
        int iNSP, iEWP, iThisScore;
        
        switch (iState) {
            case BOARD_NUMBER:
                iCurrentBoard = GetInputFieldNumber(sL);
                // Check for validity
                if (iCurrentBoard < 1 || iCurrentBoard > mDef.boards) {
                    // Invalid entry
                    InputField.setText("");
                    Ding();
                    break; // Bag it, remain in BOARD_NUMBER state
                } // End if iCurrentboard
                
                // Yes we have a valid board number
                LabelBoardNumber.setText("Board Number:  " + 
                    Integer.toString(iCurrentBoard));
                
                //if (BoardListModel == null) 
                //    JOptionPane.showMessageDialog(null,"BoardListModel ref is null");
                //else
                //    JOptionPane.showMessageDialog(null,"BoardListModel ref is not null");

                boardArray[iCurrentBoard - 1].WriteUponList(BoardListModel);
                if (boardArray[iCurrentBoard - 1].IsBlank()) {
                    iCurrentScoreEntry = 0;
                    // Look up the top pair number and display prompt
                    iNSP = boardArray[iCurrentBoard - 1]
                        .BDcontent[iCurrentScoreEntry].NSpair;
                    iEWP = boardArray[iCurrentBoard - 1]
                        .BDcontent[iCurrentScoreEntry].EWpair;
                    DataEntryInstruction.setText("Score for NS "
                        + Integer.toString(iNSP) + " vs. EW "
                        + Integer.toString(iEWP) + ":");
                    iState = SCORE;
                    
                } else {
                    // This score has already been entered
                    iState = CONFIRM;
                    DataEntryInstruction.setText(
                        "Hit ENTER to accept, or SPACE BAR to re-enter data.");
                }
                InputField.setText("");
                BoardList.setVisible(true);
                break;
                
            case SCORE:
                // Get number, display prompt for next score; or if complete
                //   shift to CONFIRM state.
                    iThisScore = GetInputFieldNumber(sL);
                    if (iThisScore < -10000 || iThisScore > 10000
                        || (iThisScore - 10*(iThisScore/10) != 0)) {
                        // Invalid score
                        Ding();
                        InputField.setText("");
                    } else {
                        // Valid score
                        boardArray[iCurrentBoard - 1]
                            .BDcontent[iCurrentScoreEntry].NetScore = iThisScore;
                        if (iThisScore < 0) {  // EW won
                            boardArray[iCurrentBoard - 1]
                                .BDcontent[iCurrentScoreEntry].NSscore = 0;
                            boardArray[iCurrentBoard - 1]
                                .BDcontent[iCurrentScoreEntry].EWscore = -iThisScore;
                        } else { // NS won
                            boardArray[iCurrentBoard - 1]
                                .BDcontent[iCurrentScoreEntry].NSscore = iThisScore;
                            boardArray[iCurrentBoard - 1]
                                .BDcontent[iCurrentScoreEntry].EWscore = 0;
                        }
                        
                        boardArray[iCurrentBoard - 1].WriteOneScore(BoardListModel,
                            iCurrentScoreEntry);
                        iCurrentScoreEntry++;
                        if (iCurrentScoreEntry 
                            >= boardArray[iCurrentBoard - 1].BDcontent.length) {
                            // Data entry for board has been completed
                            iState = CONFIRM;
                            DataEntryInstruction.setText(
                                "Hit ENTER to accept, or SPACE BAR to re-enter data.");
                        } else {
                            // Data entry for board must continue   
                            // Look up the top pair number and display prompt
                            iNSP = boardArray[iCurrentBoard - 1]
                                .BDcontent[iCurrentScoreEntry].NSpair;
                            iEWP = boardArray[iCurrentBoard - 1]
                                .BDcontent[iCurrentScoreEntry].EWpair;
                            DataEntryInstruction.setText("Score for NS "
                                + Integer.toString(iNSP) + " vs. EW "
                                + Integer.toString(iEWP) + ":");
                            iState = SCORE;
                        }
                    } // End else valid score
                    InputField.setText("");
                break;
                
            case CONFIRM:
                if (InputField.getText().length() == 0) {
                    // Data for board entered.  
                    // Analyze, post, then clear and get new board.
                    AssignAllPoints(iCurrentBoard);
                    if (mDef.type == 'H')
                         ComputeRankingHowell(iCurrentBoard);
                    else ComputeRankingMitchell(iCurrentBoard);
                    boardArray[iCurrentBoard - 1].bDataEntered = true;
                    if (AllBoardsEntered()) {
                       ShowWinnersButton.setEnabled(true);
                       ExportButton.setEnabled(true);
                       ShowBothRankings();
                    }
                    bDataHasBeenExported = false;
                    DataEntryInstruction.setText("Enter Board Number:");
                    LabelBoardNumber.setText("       ");
                    iState = BOARD_NUMBER;
                } else {
                    // Data rejected, start re-entry.   
                    iCurrentScoreEntry = 0;
                    // Look up the top pair number and display prompt
                    iNSP = boardArray[iCurrentBoard - 1]
                        .BDcontent[iCurrentScoreEntry].NSpair;
                    iEWP = boardArray[iCurrentBoard - 1]
                        .BDcontent[iCurrentScoreEntry].EWpair;
                    DataEntryInstruction.setText("Score for NS "
                        + Integer.toString(iNSP) + " vs. EW "
                        + Integer.toString(iEWP) + ":");
                    iState = SCORE;
                }
                InputField.setText("");
                break;
        } // End switch
 
    } // End Process input line
    
    // ==========================================
    // MISCELLANEOUS METHODS
    //===========================================
    
    void Ding() {
        char c;
        c = (char)7;  //Bell
        //System.out.print(c);
        //System.out.flush();
        toolkit.beep();
        JOptionPane.showMessageDialog(null,"Invalid Entry, Please Re-enter.");
        
    }
    
    File SelectMovement() {
        // This will return a File, guaraneed to exist, that contains the 
        // movement definition.
        Object[] MovementNames = {
            "Two tables, three boards each round",
            "Two tables, four boards each round",
            "Two tables, five boards each round",
            "2.5 tables, 10 boards",
            "2.5 tables, 15 boards",
            "2.5 tables, 20 boards",
            "3 tables, 10 boards",
            "3 tables, 15 boards",
            "3 tables, 20 boards",
            "3.5 tables, 14 boards",
            "3.5 tables, 21 boards",
            "3.5 tables, 28 boards",
            "4 tables, 14 boards",
            "4 tables, 21 boards",
            "4 tables, 28 boards",
            "4.5 table Mitchell, 10 boards",
            "4.5 table Mitchell, 15 boards",
            "5 table Mitchell, 10 boards",
            "5 table Mitchell, 15 boards"
        };
        
        Object[] MovementFiles = {
            "H2P0-9",
            "H2P0-12",
            "H2P0-15",
            "H2P5-10",
            "H2P5-15",
            "H2P5-20",
            "H3P0-10",
            "H3P0-15",
            "H3P0-20",
            "H3P5-14",
            "H3P5-21",
            "H3P5-28",
            "H4P0-14",
            "H4P0-21",
            "H4P0-28",
            "M4P5-10",
            "M4P5-15",
            "M5P0-10",
            "M5P0-15"
        };
        
        String s = (String)JOptionPane.showInputDialog(
                    this,
                    "Select a movement from the following list:",
                    "Select Movement",
                    JOptionPane.PLAIN_MESSAGE,
                    null,
                    MovementNames,
                    MovementNames[0]);
        // If no processor selected, exit the program.
        if (s == null) System.exit(0);
        // Now we need to retrieve the corresponding file name.
        
        int N = MovementNames.length;
        String sSelectedFileName = null;
        int i;
        for (i = 0; i < N; i++)
            if (s.compareTo(MovementNames[i]) == 0) {
                sSelectedFileName = (String)MovementFiles[i];
                break;
            }
        // Now we should have had a hit, but let's check
        if (sSelectedFileName == null) {
            JOptionPane.showMessageDialog(this, "Can't match a file name to selected movement.");
            System.exit(0);
        }
        
        // We now have a file name.  But in which director is it?
        //String sCurrentDir = System.getProperty("user.dir");
        //String sHomeDir = System.getProperty("user.home");
               
        //JOptionPane.showMessageDialog(this, "File name is " + sSelectedFileName
        //    + "\nCurrent directory is " + sCurrentDir
        //    + "\nUser Home Directory is " + sHomeDir);
        //
        // These are the only places to look in
        // Following moved to constructor
        String sFileSeparator = System.getProperty("file.separator");
        String sCurrentPath = sCurrentDir + sFileSeparator + sSelectedFileName + ".txt";
        String sHomePath = sHomeDir + sFileSeparator + sSelectedFileName + ".txt";
        File CurrentFile = new File(sCurrentPath);
        File HomeFile = new File(sHomePath);
        
        if      (CurrentFile.exists()) return CurrentFile;
        else if (HomeFile.exists())    return HomeFile;
        else  {
            JOptionPane.showMessageDialog(this, "Sorry, this movement is not yet supported");
            return null;
        }
    } // End method SelectMovement
    
    void LoadMovement(File sMovementID) {
        // The input is an existing file.
        String s, s1, s2, s3, s4;
        StringTokenizer st;
        String sFileName;
        FileInputStream fiStream= null;
        BufferedReader rdr = null;
        sFileName = "C:\\JavaProg\\BridgeScoreC\\H3P0-15.txt";  // Test case; normally the file name will 
                                    // be derived from sMovementID;
        char xChar;
        boolean done = false;
        int n1, n2, n3; 
        int iMovementEntries = 0;
        int junk = 0;
        
        
        // Open the appropriate file
        File fP = /*new File(sFileName); */ sMovementID;
        try {fiStream = new FileInputStream(fP);}
            catch (FileNotFoundException e) {
                JOptionPane.showMessageDialog(this, "Cannot find movement definition.");
                System.exit(0);
        }
        rdr = new BufferedReader(new InputStreamReader(fiStream));
        // Read a string s from the file
        while (!done) {
            try {s = rdr.readLine();}
                catch (IOException e) {s = null;};
            if (s == null) done = true;
            else if (s.length() == 0) done = true;
            else { // We have an input line that we can analyze
                // If the line begins with H or M, we have a line specifying
                //    the movement properties.  If the line begins with a number,
                //    then it is a board number and we record it in Movement.
                //    Any other line is ignored.
                st = new StringTokenizer(s);
                //JOptionPane.showMessageDialog(null, "Line read is: " + s);
                if (st.hasMoreTokens()) s1 = st.nextToken(); else s1 = null;
                if (st.hasMoreTokens()) s2 = st.nextToken(); else s2 = null;
                if (st.hasMoreTokens()) s3 = st.nextToken(); else s3 = null;
                if (st.hasMoreTokens()) s4 = st.nextToken(); else s4 = null;
                //JOptionPane.showMessageDialog(null, "Tokens are: "
                //    + s1 + "\n" + s2 + "\n" + s3 + "\n" + s4);
                if (s1.equals("H") || s1 .equals("M")) {
                    // Movement properties line
                    try {
                        mDef.type = s1.charAt(0); // I.e. the H or M;
                        mDef.boards = Integer.parseInt(s2);
                        mDef.tables = Integer.parseInt(s3);
                        mDef.rounds = Integer.parseInt(s4);
                        //mDef = new MovementDefinition(mProperties); //TROUBLE HERE
                    } catch (Exception e) {
                        JOptionPane.showMessageDialog(this,"Invalid Movement File");
                        System.exit(0);
                    }
                    //JOptionPane.showMessageDialog(null, "Boards/Tables/Rounds" 
                    //    + Integer.toString(mDefA.boards)
                    //    + Integer.toString(mDefA.tables)
                    //    + Integer.toString(mDefA.rounds));
                } else {
                    // Board pair line, possibly   
                    try {
                        n1 = Integer.parseInt(s1);
                        n2 = Integer.parseInt(s2);
                        n3 = Integer.parseInt(s3);
                        //JOptionPane.showMessageDialog(this,"mDef Line "
                        //    + Integer.toString(iMovementEntries) + "\n"
                        //    + Integer.toString(n1) +  " " + Integer.toString(n2)
                        //    + " " + Integer.toString(n3));
                        // If we haven't thrown an exception by now, we have a line
                        // with three numbers
                        mDef.content[iMovementEntries].board  = n1;
                        mDef.content[iMovementEntries].NSpair = n2;
                        mDef.content[iMovementEntries].EWpair = n3;
                        iMovementEntries++;
                    } catch (NumberFormatException e) {
                        //JOptionPane.showMessageDialog(this,"Parsing Exception");
                    };
                } // End else possible board pair line
            } // End else we have an input line that we can analyze
        } // End while
        mDef.iEntries = iMovementEntries;
    } // End LoadMovement
    
    int GetInputFieldNumber(String sL) {
        // will return an invalid board/score if garbage
        int iResult;
        String sL2 = sL.trim();
        try {iResult = Integer.parseInt(sL2);}
        catch (NumberFormatException e) {iResult = 100000;}
        return iResult;
    }
    
    String FormatScore(int x) {
        // Imput is a number of HALF points.
        // Output is a string of length 5, such as bb1.5 if x=3
        int q = x/2; // The number of points
        String p1, p2, y ;
        p1 = Integer.toString(q);
        if (x - 2*q == 0) p2 = ".0"; else p2 = ".5";
        y = p1 + p2;
        while (y.length() < 5) y = " " + y;
        return y;
    }
    
    String FormatInt(int x, int FieldWidth, int TrailBlanks) {
        // Returns a string of length FieldWidth + TrailBlanks
        int i;
        String y = Integer.toString(x);
        while (y.length() < FieldWidth) y = " " + y;
        for (i = 0; i < TrailBlanks; i++) y = y + " ";
        return y;
    }
    
    void AssignAllPoints(int iBd) {
        BoardData bdX = boardArray[iBd - 1]; // Simplifies following references
        int n = bdX.BDcontent.length;
        // Build pair-number and half-points arrays 
        int[] iNetScores = new int[n];
        int[] iHP = new int[n];
        int[] iAssignedNSHPoints;
        int i;
        for (i = 0; i < n; i++) {
            iNetScores[i]   = bdX.BDcontent[i].NetScore;
        }
        iAssignedNSHPoints = AssignPoints(iNetScores);
        for (i = 0; i < n; i++) {
            bdX.BDcontent[i].NSHpoints = iAssignedNSHPoints[i];
            bdX.BDcontent[i].EWHpoints = 2*(n - 1) - iAssignedNSHPoints[i];
        }
    }
    
    void ComputeRankingHowell(int iBd) {
        BoardData bdX = boardArray[iBd - 1]; // Simplifies following references
        int n = bdX.BDcontent.length;
        int i;
        for (i = 0; i < n; i++) {
            //JOptionPane.showMessageDialog(this, "n = " + Integer.toString(n)
            //    + " and i = " + Integer.toString(i));
            //JOptionPane.showMessageDialog(this, "iBd = " + Integer.toString(iBd)
             //   + " and second index = " + Integer.toString( bdX.BDcontent[i].NSpair ));
            NSResults.content[iBd - 1][bdX.BDcontent[i].NSpair - 1]
                = bdX.BDcontent[i].NSHpoints;
            NSResults.content[iBd - 1][bdX.BDcontent[i].EWpair - 1]
                = bdX.BDcontent[i].EWHpoints;
        }//
        // Now update the lines in the NSListModel
        NSResults.WriteScoreRow(NSListModel, iBd);
    } // End ComputeRankingHowell
    
    void ComputeRankingMitchell(int iBd) {
        BoardData bdX = boardArray[iBd - 1]; // Simplifies following references
        int n = bdX.BDcontent.length;
        // Build separate pair-number and half-points arrays for NS and EW
        int i;
        for (i = 0; i < n; i++) {
            NSResults.content[iBd - 1][bdX.BDcontent[i].NSpair - 1]
                = bdX.BDcontent[i].NSHpoints;
            EWResults.content[iBd - 1][bdX.BDcontent[i].EWpair - 1]
                = bdX.BDcontent[i].EWHpoints;
        }//
        // Now update the lines in the NSListModel and the EWListModel
        NSResults.WriteScoreRow(NSListModel, iBd);
        EWResults.WriteScoreRow(EWListModel, iBd);
    } // End ComputeRankingMitchell
    
    int[] AssignPoints(int[] iSc) {
        // 
        // Input: iSc[i] is the score of pair number i
        // Output: iHPResult[i] will be the half-points earned the pair
        //         identified in iPR[i]
        int n = iSc.length;
        int i, j, z;
        int[] iIndex = new int[n+1];
        int[] iScores = new int[n+1];
        int[] iHPoints = new int[n+1];
        int[] iHPResult = new int[n]; // We will return this
        for (i = 0; i < n; i++) {
            iIndex[i] = i;
            iScores[i] = iSc[i];
            iHPoints[i] = 0;  // We'll fill this in later
        }
        // Sort the (iIndex, iScores) array by score
        // We will use a simple bubble sort.
        for (i = 1; i < n; i++) {
            // Bubble up the entry at position i
            for (j = i; j > 0; j--) {
                if (iScores[j] > iScores[j-1]) {
                    // Interchange entries at j and j-1
                    z = iScores[j];
                    iScores[j] = iScores[j-1];
                    iScores[j-1] = z;
                    z = iIndex[j];
                    iIndex[j] = iIndex[j-1];
                    iIndex[j-1] = z;
                }
            }
        } // Completion of bubble sort exercise
        
        // Now we assign half-points and store in the iPoints array
        iScores[n] = -10000; // Dummy value to terminate last group
        int iGpStart = 0;
        int iGpEnd   = 1;
        int iGpHPts = 0;
        while (iGpStart < n) {
            // Identify the end of a group of equal scores
            while (iScores[iGpEnd] == iScores[iGpStart] 
                && iGpEnd < n) iGpEnd++;
            // At this point, iGpStart points to the start of a group 
            // of equal scores, and iGpEnd point to just past the end
            // of the group.  The size of the group is iGpEnd - iGpStart.
            iGpHPts = (n -iGpStart - 1) + (n - iGpEnd);
            for (i = iGpStart; i < iGpEnd; i++)
                iHPoints[i] = iGpHPts;
            iGpStart = iGpEnd;
            iGpEnd = iGpStart + 1;
        }
        // Transfer results to the output
        for (i = 0; i < n; i++) {
            iHPResult[iIndex[i]] = iHPoints[i];
        }
        
        //JOptionPane.showMessageDialog(null, Integer.toString(n)
        //    + "\n" + Integer.toString(iSc[0]) 
        //    + " " + Integer.toString(iSc[1]) 
        //    + " " + Integer.toString(iSc[2])
        //    + "\n" + Integer.toString(iHPResult[0]) 
        //    + " " + Integer.toString(iHPResult[1]) 
        //    + " " + Integer.toString(iHPResult[2])  
        //  );
        return iHPResult;
    }
    
    boolean AllBoardsEntered() {
        boolean x = true;
        int i;
        for (i = 0; i < mDef.boards; i++)
            x = x && boardArray[i].bDataEntered;
        return x;
    }
    
    void ShowBothRankings() {
        String s = BuildBothRankings();
        if (fanfare == null) toolkit.beep();
        else fanfare.play();
        //JOptionPane.showMessageDialog(this, s);
       JOptionPane.showMessageDialog(null, s); 
    }
    
    String BuildBothRankings() {
        String s;
        if (mDef.type == 'H') {
            s = ShowRanking(NSResults);
        } else {
            s = "NORTH-SOUTH:\n" + ShowRanking(NSResults)
                + "\nEAST-WEST:\n" + ShowRanking(EWResults);
        }
        return s;
    }
    
    String ShowRanking(ResultTable ThisResult) {
        int N = mDef.Pairs();
        SpecificPlaceResult  GotStuff;
        String sMessage;
        int i, j, n, iNewCon;
        int[] iScores = new int[N];
        // Copy the scores we are interested in
        for (i = 0; i < N; i++) {
            iScores[i] = 0;
            for (j = 0; j < mDef.boards; j++)
                iScores[i] += ThisResult.content[j][i];
        }
        // Now pick out the winners etc.
        GotStuff = SpecificPlace(iScores, 10000, "The winner", N);
        sMessage = GotStuff.s;
        iNewCon = GotStuff.i;
        GotStuff = SpecificPlace(iScores,  iNewCon, "Second", N);
        sMessage = sMessage + "\n" + GotStuff.s;
        iNewCon = GotStuff.i;
        GotStuff = SpecificPlace(iScores,  iNewCon, "Third", N);
        sMessage = sMessage + "\n" + GotStuff.s;
        iNewCon = GotStuff.i;
        return sMessage;
    } // End ShowRanking
    
    SpecificPlaceResult  SpecificPlace (int[] iScore, int iConstraint, String sRankWord, int iN) {
        final int INVALID = 10000;
        int iPickedScore = -INVALID;
        int i, n;
        boolean WhoHas[] = new boolean[iN];
        boolean GotOne;
        String sMessage;
        SpecificPlaceResult y = new SpecificPlaceResult();
        
        
        for (i = 0; i < iN; i++) 
            if (iScore[i] > iPickedScore && iScore[i] < iConstraint) iPickedScore = iScore[i];
        // Who has the picked score?
        // [but what if there is no picked score?]
        // I PickedScore will still be -INVALID
        for (i = 0; i < iN; i++) {
            if (iScore[i] == iPickedScore) WhoHas[i] = true; else WhoHas[i] = false;
        }
        // And how many of them are there?
        n = 0;
        for (i = 0; i < iN; i++) 
            if (WhoHas[i]) n++;
        
        if (n == 0) {
            sMessage = "";
        } else if (n == 1) {
            sMessage = sRankWord + " is ";
            for (i = 0; i < iN; i++) {
                if (WhoHas[i]) {
                    sMessage = sMessage + Integer.toString(i+1);
                    break;
                }
            }
        } // End if (n == 1)
        else { // n > 1 so there is a tie
            sMessage = sRankWord + "s are ";
            GotOne = false;
            for (i = 0; i < iN; i++) {
                if (WhoHas[i] && !GotOne) {
                    sMessage = sMessage + Integer.toString(i+1);
                    GotOne = true;
                } else if (WhoHas[i] && GotOne) {
                    sMessage = sMessage + " and " + Integer.toString(i+1);
                }
            } // End for
        } // End else, which meant a tie
        // Change value of IConstraint to equal iPickedScore, so that it can be used 
        // in the next call to this method.
        y.s = sMessage;
        y.i = iPickedScore;
        return y;
    } // End SpecificPlace
    
    
// ==========================================
// EXPORT DATA TO TEXT FILE
//===========================================
    void ExportData() {
        // Use FileChooser to get folder and name of file to write
        // Create the file and opwn for writing text
        // Write NS and EW scores
        // Write winners
        // Write board-level data
        File targetFile, targetFileTxt;
        String targetString, targetStringTxt;
        JFileChooser fc;
        PrintStream psReport = null;
        String s;
        String tgtName = null;
        int i, j;
        
        fc = new JFileChooser();
        fc.setFileSelectionMode(JFileChooser.FILES_ONLY);
        int fcres = fc.showSaveDialog(this);
        if (fcres == JFileChooser.CANCEL_OPTION) return;
        
        // Get the target file name
        targetFile = fc.getSelectedFile();
        targetString = targetFile.getAbsolutePath();
        //JOptionPane.showMessageDialog(this, targetString);
        
        // If the file name does not end in ".txt", add it.
        if (targetString.endsWith(".txt")){
            targetStringTxt = new String(targetString);
        } else {
            targetStringTxt = targetString.concat(".txt");
        }
        // JOptionPane.showMessageDialog(this, targetStringTxt);
        targetFileTxt = new File(targetStringTxt);
        tgtName = targetFileTxt.getName();
        
        // Determine whether the file exists.  If it does, ask permission to overwrite.
        if (targetFileTxt.exists()) {
            if(JOptionPane.showConfirmDialog(this, 
                "File " + tgtName + " already exists. Overwrite?",
                "Confirm Replacement",
                JOptionPane.YES_NO_OPTION) == JOptionPane.NO_OPTION) return;
        }
        
        // Open the file for writing
        boolean bSuccess;
        try {
            psReport = new PrintStream(new FileOutputStream(targetFileTxt));
            psReport.println("DUPLICATE BRIDGE RESULTS - " 
                + DateFormat.getInstance().format(new Date()));
            psReport.println();
            bSuccess = true;
        } catch (FileNotFoundException e) {
            JOptionPane.showMessageDialog(this, "Error attempting to create report file.");
            bSuccess = false;
        }
        if (!bSuccess) return;
        
        // Write the data
        // Phase 1: the results:
        for (i = 1; i < 3; i++) {
            s = NSResults.buildHeaderRow(i);
            if (mDef.type == 'M') s = s + "     " + EWResults.buildHeaderRow(i);
            psReport.println(s);
        }
        for (i = 1; i <= mDef.boards; i++) {
            s = NSResults.buildBoardRow(i);
            if (mDef.type == 'M') s = s + "     " + EWResults.buildBoardRow(i);
            psReport.println(s);
        }
        for (i = 3; i < 5; i++) {
            s = NSResults.buildHeaderRow(i);
            if (mDef.type == 'M') s = s + "     " + EWResults.buildHeaderRow(i);
            psReport.println(s);
        }
        psReport.println();
        
        // Phase 2: The Winners!
        s = BuildBothRankings(); // Trouble is, this has newlines in it.
        while (s.length() > 0) {
            i = s.indexOf("\n");
            if (i > 0) {
                psReport.println(s.substring(0,i));
                s = s.substring(i+1, s.length());
            } else {
                psReport.println(s);
                s = "";
            }
        } // End while
        psReport.println();
        
        // Phase 3: Data for individual boards
        BoardDataRow ThisRow;
        for (i = 0; i < mDef.boards; i++) {
            psReport.print("BOARD ");
            psReport.println(i+1);
            psReport.println("  NS   EW   NS    EW  ");
            psReport.println(" PAIR PAIR SCORE SCORE");
            for (j = 0; j < boardArray[i].iHowOftenPlayed; j++) {
                ThisRow = boardArray[i].BDcontent[j];
                s =     FormatInt(ThisRow.NSpair,  5,  0);
                s = s + FormatInt(ThisRow.EWpair,  5,  0);
                s = s + FormatInt(ThisRow.NSscore, 6,  0);
                s = s + FormatInt(ThisRow.EWscore, 6,  0);
                psReport.println(s);
            }
            psReport.println();
        }
        
        // Close the file
        psReport.close();
        toolkit.beep();
        bDataHasBeenExported = true;
        JOptionPane.showMessageDialog(null, "Data exported to text file " + tgtName);
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel BoardID;
    private javax.swing.JList BoardList;
    private javax.swing.JLabel DataEntryInstruction;
    private javax.swing.JList EWList;
    private javax.swing.JButton ExportButton;
    private javax.swing.JTextField InputField;
    private javax.swing.JLabel LabelBoardNumber;
    private javax.swing.JList NSList;
    private javax.swing.JPanel PaneRight;
    private javax.swing.JButton ShowWinnersButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    // End of variables declaration//GEN-END:variables
    
    
    //======================================================
    // Inner classes to define data structures
    //======================================================
    
    
    class MovementDefinition  {
        char type; // 'H' or 'M'
        int  boards; // Number of boards
        int  tables; // Number of tables
        int  rounds; // Number of rounds
        int  i;
        MovementDefRow[] content;
        int iEntries;
        MovementDefinition(int contentSize) { // This is the constructor
            content = new MovementDefRow[contentSize];
        for (i = 0; i < contentSize; i++)
            content[i] = new MovementDefRow();
            // iEntries will be set to the actual size as a result of reading the file
        } // End constructor
        
        int Pairs() {
            if (type == 'H') return 2*tables; // Howell
            else if (type == 'M') return tables; // Mitchell
            else return 0; // Should never happen
        }
        int getEntryNumber() {return iEntries;}        
    }
    
    class MovementDefRow {
        int board;
        int NSpair;
        int EWpair;
        int round;
        int table;
    }
    
    
    class BoardData {
        BoardDataRow[] BDcontent;
        int            iMyNumber;
        int            iHowOftenPlayed;
        boolean        bDataEntered;
        BoardData (int b) {
            // md.content.length is the number of entries in the movement definition;
            // we have to count the number of entries for the given board
            // then create an array to hold the data from these entries
            //JOptionPane.showMessageDialog(null, "BoardData constructor " + Integer.toString(b));
            int i;
            iMyNumber = b;
            iHowOftenPlayed = 0;
            bDataEntered = false;
            for (i = 0; i < mDef.content.length; i++)
                if (mDef.content[i].board == b) iHowOftenPlayed++;
            
            //JOptionPane.showMessageDialog(null, "Board " + Integer.toString(b)
            //    + " played " + Integer.toString(iHowOftenPlayed)
             //   + " times.");
            
            BDcontent = new BoardDataRow[iHowOftenPlayed];
            for (i = 0; i < iHowOftenPlayed; i++)
                BDcontent[i] = new BoardDataRow();
            
            // Search through the movement definition md for entries with this board number
            int iEntryIndex = 0;
            for (i = 0; i < mDef.content.length; i++) {
                if (mDef.content[i].board == b) {
                    BDcontent[iEntryIndex].round   = mDef.content[i].round;
                    BDcontent[iEntryIndex].NSpair  = mDef.content[i].NSpair;
                    BDcontent[iEntryIndex].EWpair  = mDef.content[i].EWpair;
                    BDcontent[iEntryIndex].NSscore = 0;
                    BDcontent[iEntryIndex].EWscore = 0;
                    iEntryIndex++;
                }  // End if
            }  // End for
        } // End constructor BoardData
        
        boolean IsBlank() {
            // This checks whether any data has been previously entered
            boolean bResult = true;
            int n = BDcontent.length;
            int i;
            for (i = 0; i < n; i++) {
                if ((BDcontent[i].NSscore != 0) || (BDcontent[i].EWscore != 0))
                    bResult = false;
                break;
            }
            return bResult;
        } // End IsBlank
        
        void WriteUponList(DefaultListModel dlm) {
            dlm.clear(); 
            BoardID.setText("Data for Board " + Integer.toString(iMyNumber));
            dlm.addElement("  NS   EW   NS    EW   ");
            dlm.addElement(" PAIR PAIR SCORE SCORE");
            int i;
            String s;
            for (i = 0; i < iHowOftenPlayed; i++) {
                s =     FormatInt(BDcontent[i].NSpair, 5, 0);
                s = s + FormatInt(BDcontent[i].EWpair, 5, 0);
                s = s + FormatInt(BDcontent[i].NSscore, 6, 0);
                s = s + FormatInt(BDcontent[i].EWscore, 6, 0);
                dlm.addElement(s);
            }
        }
        void WriteOneScore(DefaultListModel dlm, int i) {
            String s;
            // i is the array entry index            
            s =     FormatInt(BDcontent[i].NSpair, 5, 0);
            s = s + FormatInt(BDcontent[i].EWpair, 5, 0);
            s = s + FormatInt(BDcontent[i].NSscore, 6, 0);
            s = s + FormatInt(BDcontent[i].EWscore, 6, 0);
            dlm.setElementAt(s, i+2);
        }
    } // End class BoardData
    
    class BoardDataRow {
        int round;
        int NSpair;
        int EWpair;
        int NSscore;
        int EWscore;
        int NetScore; // This and following two entries not displayed
        int NSHpoints;
        int EWHpoints;
    }
    
    class ResultTable { // We will create one of this for Howell, two for Mitchell
        // The values stored in content[][] are numbers of HALF points!!!!
        int content[][];
        int columns;
        int rows;
        String dashSubstitute;
        
        ResultTable(MovementDefinition p, char NSorEW) {
            columns = p.Pairs();
            rows = p.boards;
            content = new int[rows][columns];
            int i, j;
            for (i = 0; i < rows; i++) 
                for (j = 0; j < columns; j++)
                    content[i][j] = 0;
            // Look at columns and rows
            //JOptionPane.showMessageDialog(null,
            //    "Result table constructor\nColumns "
            //    + Integer.toString(columns)
            //    + " rows "
            //    + Integer.toString(rows));
           if (p.type == 'H')
               dashSubstitute = "PAIR:";
           else if (NSorEW == 'N')
               dashSubstitute = "  NS:";
           else 
               dashSubstitute = "  EW:";
        }
        int WidthRequirement() {
            return (int)(7.5*(float)(5*columns + 5));
        }
        int HeightRequirement() {
            return (int)(16.22*(float)(rows + 4));   
        }
        void WriteTitleRows(DefaultListModel dlm) {
            // Set list elements 0, 1, and whatever to titles and lines
            int i;
            String s, t;
            s = dashSubstitute;
            
            t = "BOARD";
            for (i = 0; i < columns; i++) {
                s = s + FormatInt(i + 1, 5, 0);
                t = t + "     ";
            }
            // s is the header
            // t is a horizontal line
            dlm.addElement(s);
            dlm.addElement(t);
            for (i = 0; i < rows; i++){
                s = FormatInt(i+1, 2, 3);
                dlm.addElement(s);
            }
            dlm.addElement("-----"); // Another horizontal line
            dlm.addElement("Total");
        }
        
        void WriteScoreRow(DefaultListModel dlm, int board) {
            // Write the given scores for this board to the list.
            // Then update totals and display them too.
            int i, j, sum;
            String s;
            s = FormatInt(board, 2, 3);
            for (i = 0; i < columns; i++)
                s = s + FormatScore(content[board - 1][i]);
            dlm.setElementAt(s, board + 1);
        
            // Then update totals and display them too.
            s = "Total";
            for (i = 0; i < columns; i++) {
                sum = 0;
                for (j = 0; j < rows; j++)
                    sum = sum + content[j][i];
                s = s + FormatScore(sum);
            }
            dlm.setElementAt(s, rows+3);
        } // End WriteScoreRow
        
        String buildHeaderRow(int n) {
            // n = 1, 2, 3, 4 correspond to two header rows, dash row, and sum row
            // All strings returned are of length 5*(columns + 1)
            int i, j, sum;
            String s = null;
            switch (n) {
                case 1:
                    s = dashSubstitute;
                    for (i = 0; i < columns; i++)
                        s = s + FormatInt(i + 1, 5, 0);
                    break;
                case 2:
                    s = "BOARD";
                    for (i = 0; i < columns; i++)
                        s = s + "     ";
                    break;
                case 3:
                    s = "-----";
                    for (i = 0; i < columns; i++)
                        s = s + " ----";
                    break;
                case 4:
                    s = "Total";
                    for (i = 0; i < columns; i++) {
                        sum = 0;
                        for (j = 0; j < rows; j++)
                            sum = sum + content[j][i];
                        s = s + FormatScore(sum);
                    };
                    break;
            } // End switch
            return s;
        }  // End buildHeaderRow method
        
        String buildBoardRow(int n) {
            //n is the board number
            int i;
            String s;
            s = FormatInt(n, 2, 3);
            for (i = 0; i < columns; i++)
                s = s + FormatScore(content[n - 1][i]);
            return s;
        }
        
    } // End class ResultTable
    
    class SpecificPlaceResult {
        String s;
        int i; // the score reported on
    }
} // End of BridgeScore

class MyCanvas extends Canvas {
    public MyCanvas(Image IX) {
        localImage = IX;
    }
    public void paint(Graphics gg) {
        gg.drawImage(localImage, 0, 0, null);
    }
    private Image localImage;
}
